/*
 * Copyright (c) 2004 by Tsuyoshi Iguchi (zinnia@risky-safety.org)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: flip_palette.c,v 1.4 2004/05/18 03:49:36 zinnia Exp $
 */
#include "sps.h"

//// XXX flip_iidx7th.c
extern void draw_with_scale(SPS_Scene* scene, float scalex, float scaley);

static gboolean Process(SPS_Flip_Parameter* param)
{
	const int ms = 500;
	double scale;
	SPS_Scene* scene = param->scene_after;

	double ratio = (double)(param->tick_current - param->tick_begin) / (double)ms;
	if(scene == NULL) return FALSE;
	if(ratio > 1.0) ratio = 1.0;
	
	glColor4f(1.0, 1.0, 1.0, 1.0);

	SPS_Draw_Parameter dparam;
	dparam.alpha = 1.0;
	dparam.shade = TRUE;
	SPS_Scene_Draw_Generic(scene, SPS_DRAW_PARAMETER_ENUM_ALPHA,
			       &dparam, TRUE);

	scale = 1.1 * (1.0 + ratio);
	glColor4f(1.0, 1.0, 1.0, 0.9 * (1.0 - ratio));
	draw_with_scale(scene, scale, scale);

	scale = 1.3 * (1.0 + ratio);
	glColor4f(1.0, 1.0, 1.0, 0.7 * (1.0 - ratio));
	draw_with_scale(scene, scale, scale);

	scale = 1.5 * (1.0 + ratio);
	glColor4f(1.0, 1.0, 1.0, 0.5 * (1.0 - ratio));
	draw_with_scale(scene, scale, scale);

	if(ratio == 1.0) return FALSE;
	return TRUE;
}

SPS_Flip_Vector palette_vector = {
	TRUE, // require_opengl
	"Palette", // name
	"Forget me not...", // description
	FALSE, // disappear
	TRUE, // appear
	Process,
};

	
